"use strict";

var DisillusionBlock = cc.Class.extend(
{
    /** @lends DisillusionBlock.prototype */

    /**
     *  @constructs
     */
    ctor: function()
    {
        this.reset();
    },

    reset: function()
    {
        this.pieceViewsBlocked = [];
    },

    /**
     * GAME-1400 Block piece and schedule to remove.
     */
    block: function(boardObject, pieceBlocked, consumed)
    {
        var pieceView = pieceBlocked.pieceView;  
        if (this.pieceViewsBlocked.indexOf(pieceView) <= -1) {
            pieceBlocked.block(consumed);
            pieceView.updateFromModel();
            this.pieceViewsBlocked.push(pieceView);
        }
    },

    /**
     * @return {Boolean} if unblocking now.
     */
    unblock: function(consumed)
    {
        var unblocked = false;
        for (var i = this.pieceViewsBlocked.length - 1; 0 <= i; i--) {
            var pieceView = this.pieceViewsBlocked[i];
            if (pieceView.pieceModel.unblock(consumed)) {
                pieceView.updateFromModel();
                this.pieceViewsBlocked.splice(i, 1);
                unblocked = true;
            }
        }
        return unblocked;
    }
});
