/*global require*/
/*global cc*/
/*global LumosityUtils*/

require( "src/Utility/LumosityUtils.js" );

/**
 * The CloudsSettings settings.
 * @class
 * @name CloudsSettings
 */
var CloudsSettings;
( function()
{
	"use strict";

	CloudsSettings = cc.Class.extend(
	{
		/** @lends CloudsSettings.prototype */
        
        /**
         *  CloudsSettings is the main class for a clouds settings!
         *
         *  @constructs
         *  @param {array} Settings that define the clouds.
         */
        ctor: function( settings )
        {
            var self = this;
        	// Copies all the properties of settings and makes them
        	// properties of this class.
        	LumosityUtils.forEachIn( settings, function( name, value )
        	{
        		self[ name ] = value;
        	});
        }
	} );
}() );
