/*global require*/
/*global cc*/
/*global LumosityAspectNode*/
/*global LumosityUtils*/

require( "src/View/LumosityAspectNode.js" );
require( "src/Utility/LumosityUtils.js" );

var CloudsView;
(function()
{
    "use strict";

    CloudsView = LumosityAspectNode.extend(
    {
        _clouds: null,
        /** @lends CloudsView.prototype */
        
        /**
         *  CloudsView is the main class for a clouds view!
         *
         *  @constructs
         */
        ctor: function( scaleToMin )
        {
            this._super( scaleToMin );

            this._clouds = [];
        },

        addCloud: function( cloud )
        {
            this._clouds.push( cloud );
            this.addChild( cloud );
        },

        /**
        * Removes all cloud sprites from the view.
        */
        removeAllClouds: function()
        {
            var self = this;
            this._clouds.forEach( function( cloud )
            {
                self.removeChild( cloud );
            } );

            this._clouds.length = 0;
        },

        /**
        *  Animates the cloud sprites with a given sequence.
        *
        *  @param {cc.Sequence} Animation sequence.
        */
        setCloudsAnimation: function( sequence )
        {
            this._clouds.forEach( function( cloud )
            {
                cloud.runAction( sequence.clone() );
            } );
        }
    } );
}() );
