/*global require*/
/*global GameSettings*/

require( "src/Game/Base/GameSettings.js" );
require( "src/Game/MemoryMatchSettings.js" );

var MemoryMatchOverdriveSettings;
( function()
{
    "use strict";
    
    MemoryMatchOverdriveSettings = MemoryMatchSettings.extend(
    {
        /** @lends MemoryMatchOverdriveSettings.prototype */
        
        /**
         * The settings file for the game, Memory Match Overdrive!
         *
         * @constructs
         * @param {string} fileLocation The location of this settings file on the disk.
         * @param {boolean} [convertKeysToLowercase=true] If true, then all root keys from the JSON file will be converted to lowerCamelCase
         */
        ctor:function( fileLocation, convertKeysToLowercase )
        {
            this._super( fileLocation, convertKeysToLowercase );
        }
    } );
}() );