var cc = cc;
var require = require;

/**
 * Discrete enumerated states that a penguin can be in. Penguin can only be in one state at a time.
 *
 * @type {{IdleUp: number, IdleDown: number, IdleLeft: number, IdleRight: number, WalkingUp: number, WalkingDown: number, WalkingLeft: number, WalkingRight: number, Won: number, Lost: number, Waving: number, Count: number}}
 */
var PenguinStates =
{
    IdleUp:         0,
    IdleDown:       1,
    IdleLeft:       2,
    IdleRight:      3,
    WalkingUp:      4,
    WalkingDown:    5,
    WalkingLeft:    6,
    WalkingRight:   7,
    Won:            8,
    Lost:           9,
    Waving:         10,

    Count:          11,
};

var PenguinStateNames =
[
    "IdleUp",
    "IdleDown",
    "IdleLeft",
    "IdleRight",
    "WalkingUp",
    "WalkingDown",
    "WalkingLeft",
    "WalkingRight",
    "Won",
    "Lost",
    "Waving"
];