var require = require;

require( "src/Game/Base/GameSettings.js" );
var GameSettings = GameSettings;

/**
 * The Penguin Pursuit settings.
 * @class
 * @name PenguinPursuitSettings
 */
var PenguinPursuitSettings = GameSettings.extend(
{
    /** @lends PenguinPursuitSettings.prototype */

    /**
     * Gets the minimum amount of turns allowed for a maze path at a given level.
     *
     * @param levelIndex    Zero-based level index.
     * @returns {*}         Level-specific number or default number if it doesn't exist.
     */
    getMinPathTurns:function( levelIndex )
    {
        if ( this.levels[levelIndex].minPathTurns )
        {
            return this.levels[levelIndex].minPathTurns;
        }
        return this.defaultMinPathTurns;
    },

    /**
     * Gets the maximum amount of turns allowed for a maze path at a given level.
     *
     * @param levelIndex    Zero-based level index.
     * @returns {*}         Level-specific number or default number if it doesn't exist.
     */
    getMaxPathTurns:function( levelIndex )
    {
        if ( this.levels[levelIndex].maxPathTurns )
        {
            return this.levels[levelIndex].maxPathTurns;
        }
        return this.defaultMaxPathTurns;
    }
});
