/*global cc*/
/*global require*/
/*global LayoutLoader*/
/*global LumosityUtils*/

require( "src/Animation/LayoutLoader.js" );
require( "src/Utility/LumosityUtils.js" );

var Dashboard;
( function()
{
    "use strict";
    
    Dashboard = cc.Node.extend(
    {
        _target: null,

        /** @lends Dashboard.prototype */
        
        /**
         *  Dashboard is the main class for a Dashboard view!
         *
         *  @constructs
         */
        ctor:function( target, contentSize )
        {
            this._super();

            this._target = target;
        
            // When using [bounds] in layout file.
            // Must have contentSize before creating layout.
            this.setContentSize( contentSize );

            this._loadLayout();
            this._createViews();

            this.nodeName = "Dashboard";
        },

        _createViews: function()
        {

        },

        _getSlot: function( slotIndex )
        {
            var slot = null;
            slot = this[ "slot" + slotIndex ];
            return slot;
        },

        setSlotImage: function( slotIndex, imageName )
        {
            var slot = null;
            //var spriteFrame = null;

            slot = this._getSlot( slotIndex );
            if( !slot )
            {
                return;
            }

            var texture = cc.TextureCache.getInstance().addImage( "dashboardUI/" + imageName );
            var textureSize = texture.getContentSize();
            var spriteFrame = cc.SpriteFrame.createWithTexture( texture, cc.rect( 0, 0, textureSize.width, textureSize.height ) );

            //spriteFrame = cc.SpriteFrameCache.getInstance().getSpriteFrame( imageName );

            // Set the slot's image.
            slot.setDisplayFrame( spriteFrame );
        },

        displaySlot: function( slotIndex, isVisible )
        {
            var slot = null;

            slot = this._getSlot( slotIndex );
            if( !slot )
            {
                return;
            }

            slot.setVisible( isVisible );
        },

        _loadLayout: function()
        {
            LayoutLoader.loadLayoutFile( "layoutDashboard.json", this, this , this._layoutCreatingNode.bind( this ) );
        },

        _layoutCreatingNode: function( nodeName, nodeData )
        {
            var result = null;
            return result;
        },

        layout_settingNodeFlags: function( nodeName, nodeData, node )
        {
            var nodeFlags = 0xFF;
            nodeFlags &= ~( LayoutNodeFlags.RootScale );
            return nodeFlags;
        } 
    } );
}() );
