/*global require*/
/*global GameSettings*/
/*global LumosityUtils*/

require( "src/Game/Base/GameSettings.js" );
require( "src/Utility/LumosityUtils.js" );

/**
 * The Pet Detective settings.
 * @class
 * @name PetDetectiveSettings
 */
var PetDetectiveSettings;
( function()
{
    "use strict";
    
    PetDetectiveSettings = GameSettings.extend(
    {
        /** @lends PetDetectiveSettings.prototype */

        getTrialCount: function()
        {
        	var trialCount = this.trialCount;

        	if( LumosityUtils.isShortGamesModeOn() )
        	{
        		// Only 1 trial in short game mode.
        		trialCount = 1;
        	}

        	return trialCount;
        }
    } );
}() );
