/*global require*/
/*global cc*/
/*global LumosityUtils*/

require( "src/Utility/LumosityUtils.js" );

/**
 * The PracticeStreet settings.
 * @class
 * @name PracticeStreetSettings
 */
var PracticeStreetSettings;
( function()
{
    "use strict";
    
    PracticeStreetSettings = cc.Class.extend(
    {
        /** @lends PracticeStreetSettings.prototype */
        
        /**
        * The PracticeStreet settings.
        * @constructs
        */
        ctor: function( practiceSettings )
        {
            var self = this;
            // Copies all the properties of settings and makes them
            // properties of this class.
            LumosityUtils.forEachIn( practiceSettings, function( name, value )
            {
                self[ name ] = value;
            } );
        },

        getPracticeTrialInfo: function( practiceTrial )
        {
            var index = practiceTrial - 1;
            var practiceTrialInfo = this.trials[ index ];
            return practiceTrialInfo;
        }
    } );
}() );
