/*global require*/

require( "src/Game/Base/GameSettings.js" );
/*global GameSettings*/
require( "src/Utility/LumosityUtils.js" );
/*global lu*/

var PinballRecallSettings;
( function()
{
    "use strict";

    PinballRecallSettings = GameSettings.extend(
    {
        ctor: function( settings )
        {
            this._super( settings, false );
        },

        getLevel: function( levelNumber )
        {
            // The rest of the game refers to levels by one-indexed numbers.
            // This is the only place we need a zero-indexed value.
            return this.levels[ levelNumber - 1 ];
        },

        getLevelIndexForLevelNumber: function( levelNumber )
        {
            var i;
            for ( i = 0; i < this.levels.length; i += 1 )
            {
                if ( this.levels[ i ].number === levelNumber )
                {
                    return i;
                }
            }

            return -1;
        },

        getMaxTrials: function()
        {
            if ( lu.isShortGamesModeOn() )
            {
                return this.debugShortGameMaxTrials;
            }
            
            return this.maxTrials;
        },

        __getRandomLevel: function()
        {
            return this.levels.getRandomElement();
        }
    } );
}() );
