/*global cc*/
/*global require*/

require( "src/Game/RaindropsUtils.js" );
/*global RaindropsUtils*/
require( "src/View/LumositySprite.js" );
/*global LumositySprite*/

var RaindropsCloud;
( function()
{
    "use strict";

    RaindropsCloud = cc.Node.extend(
    {
        _xVelocity: null,
        _sprite: null,

        ctor: function( size, imageFileName, xVelocity, opacity )
        {
            this._super();

            this._xVelocity = xVelocity;

            this._sprite = cc.Sprite.create( imageFileName );
            this._sprite.setAnchorPoint( cc.PointZero() );
            this._sprite.setOpacity( opacity );
            this.addChild( this._sprite );

            this.setContentSize( this._sprite.getContentSize() );
        },

        update: function( deltaTime )
        {
            var x = this.getPositionX();
            x += this._xVelocity * deltaTime;
            this.setPositionX( x );
        },

        fadeOut: function( duration )
        {
            var fade = cc.FadeTo.create( duration, 0.0 );
            var sequence = cc.Sequence.create( fade );
            this._sprite.runAction( sequence );
        }
    } );
}() );
