/*global cc*/
/*global require*/

require( "src/Utility/LumosityUtils.js" );
/*global lu*/

var RaindropsEquationRange;
( function()
{
    "use strict";

    RaindropsEquationRange = cc.Class.extend(
    {
        _leftOperandRange: null,
        _rightOperandRange: null,

        ctor: function()
        {
            this._leftOperandRange = [ 0, 0 ];
            this._rightOperandRange = [ 0, 0 ];
        },

        init: function( leftOperandLowerRange, leftOperandHigherRange, rightOperandLowerRange, rightOperandHigherRange )
        {
            var leftOperandRange = [ leftOperandLowerRange, leftOperandHigherRange ];
            var rightOperandRange = [ rightOperandLowerRange, rightOperandHigherRange ];
            this._init( leftOperandRange, rightOperandRange );
        },

        _init: function( leftOperandRange, rightOperandRange )
        {
            this._leftOperandRange = leftOperandRange;
            this._rightOperandRange = rightOperandRange;
        },

        isValid: function()
        {
            return ( this.isLeftOperandRangeValid() && this.isRightOperandRangeValid() );
        },

        getLeftOperandRange: function()
        {
            return this._leftOperandRange;
        },

        isLeftOperandRangeValid: function()
        {
            return this.isRangeValid( this.getLeftOperandRange() );
        },

        getLeftOperand: function()
        {
            return this.getOperand( this._leftOperandRange );
        },

        getRightOperandRange: function()
        {
            return this._rightOperandRange;
        },

        isRightOperandRangeValid: function()
        {
            return this.isRangeValid( this.getRightOperandRange() );
        },

        getRightOperand: function()
        {
            return this.getOperand( this._rightOperandRange );
        },

        isRangeValid: function( range )
        {
            if ( range[ 0 ] > range[ 1 ] )
            {
                return false;
            }
            
            if ( range[ 0 ] === 0 && range[ 1 ] === 0 )
            {
                return false;
            }
            
            return true;
        },

        getOperand: function( range )
        {
            return lu.getRandomInt( range[ 0 ], range[ 1 ] );
        }
    } );
}() );
