/*global audio*/
/*global require*/

require( "src/Game/RaindropsDroplet.js" );
/*global RaindropsDroplet*/

var RaindropsSun;
(function()
{
    "use strict";

    RaindropsSun = RaindropsDroplet.extend(
    {
        /** @lends v.prototype */

        ctor: function( operatorPadding )
        {
            this._super( operatorPadding );
        },

        getIdleAnimName: function()
        {
            return "sunIdle";
        },
        
        getBurstAnimName: function()
        {
            return "sunBurst";
        },

        getSplashAnimName: function()
        {
            return "";
        },

        begin: function()
        {
            this._super();

            this.ae.play( this.getIdleAnimName(), true );
            this._sunSoundId = audio.playEffect( "sounds/sun.mp3", true );
        },

        burst: function()
        {
            this._super();

            this._stopLoopingSound();
        },

        splash: function()
        {
            this._super();

            this._stopLoopingSound();
        },

        _stopLoopingSound: function()
        {
//            audio.stopAllEffects();
            audio.stopEffect( this._sunSoundId );
            audio.playEffect( "sounds/ambientRain.mp3", true );
        }
    } );
}() );

