/*global cc*/
/*global require*/
/*global GameView*/
/*global LumositySprite*/

require( "src/Game/Base/GameView.js" );
require( "src/Game/Widget/GameWidgetFeedback.js" );
require( "src/Game/Widget/GameWidgetFlipbook.js" );
require( "src/Game/Widget/GameWidgetHud.js" );
require( "src/View/LumositySprite.js" );

var SpeedPackDoorSlotItemView;
( function ()
{
    "use strict";

    SpeedPackDoorSlotItemView = LumositySprite.extend(
        {
            _sprite: null,

            doorModel: null,
            slotSize: null,
            xPos: null,
            yPos: null,
            offsets: null,
            halfDoorSizes: null,

            x: null,
            y: null,

            itemSize: [ cc.size( 90, 90 ), cc.size( 180, 90 ), cc.size( 270, 90 ), cc.size( 360, 90 ), cc.size( 450, 90 ) ],

            ctor: function ( door, slotSize, direction, position, settings )
            {
                var slotsizeIndex;
                slotsizeIndex = slotSize - 1;
                if ( slotSize >= 3 )
                {
                    slotsizeIndex = slotSize;
                }
                var itemNumber = Math.floor( Math.random() * ( settings.getShapeTypeCount()[ slotsizeIndex ] - 1 ) ).toString();
                var itemName;

                var temp;
                temp = slotSize;
                if ( slotSize >= 3 )
                {
                    temp = slotSize + 1;
                }

                if ( itemNumber < 10 )
                {
                    itemName = "items/item_" + temp.toString() + "_00" + itemNumber + ".png";
                }
                else
                {
                    itemName = "items/item_" + temp.toString() + "_0" + itemNumber + ".png";
                }

                this._super( itemName.toString() );

                this.doorModel = door;
                this.slotSize = slotSize;

                this.x = position.x;
                this.y = position.y;

                this.setContentSize( this.itemSize[ slotSize - 1 ], true, true );
                this.setAnchorPoint( cc.p( 0.5, 0.5 ) );
                this.setZOrder( 10 );

                this.setRotation( -door.rotation + 90 );
                if ( slotSize >= 2 )
                {
                    if ( direction === 6 )
                    {
                        this.setRotation( -door.rotation + 90 );
                    }
                    else if ( direction === 4 )
                    {
                        this.setRotation( -door.rotation );
                    }
                }

                this.setItemSprite();
            },

            setItemSprite: function ()
            {
                this.setPosition( cc.p( this.x, this.y ) );
                this.setZOrder( 10 );
            }
        } );
}() );
