/*global cc*/
/*global require*/
/*global GameView*/
/*global LumositySprite*/

require( "src/Game/Base/GameView.js" );
require( "src/Game/Widget/GameWidgetFeedback.js" );
require( "src/Game/Widget/GameWidgetFlipbook.js" );
require( "src/Game/Widget/GameWidgetHud.js" );
require( "src/View/LumositySprite.js" );

var SpeedPackDoorView;
( function()
{
    "use strict";
    
    SpeedPackDoorView = LumositySprite.extend(
    {
        x: null,
        y: null,
        rotation: null,
        imgSize: null,

        ctor: function( settings, door, suitcaseSize )
        {
            var doorName = "suitcases/suitcase_" + door.img.toString() + ".png";
            this._super( doorName.toString() );

            this.x = ( suitcaseSize.width / 2 ) + door.x;
            this.y = ( suitcaseSize.height / 2 ) + door.y;
            this.rotation = door.rotation;
            this.imgSize = settings.getDoorImageSize( door.img );

            this.setAnchorPoint( cc.p( 0.5, 0.5 ) );
            this.setContentSize( this.imgSize, true, true );
            this.setZOrder( 1 );

            this.setDoorSpriteProperties();
        },

        setDoorSpriteProperties: function()
        {
            this.setPosition( cc.p( this.x, this.y ) );
        }
    } );
}() );
