/*global cc*/
/*global require*/

var LevelInfoTextParser;
( function ()
{

	"use strict";

	LevelInfoTextParser = cc.Class.extend( 
    {	

        /** @lends LevelInfoTextParser */
        /**
         * The LevelInfoTextParser does just what it's name implies. When passed a .txt file, it creates an array per line 
         * Each line is it's own array, containing all level data from the .txt file
         *
         * @constructs
         */
        ctor: function( )
        {

        },

        //this is the function to actually parse the csv file
        parseTxtFileForLevelInfo: function( textFile )
        {
            var arrayOfLevelsToReturn = [];
            var tempArrayOfLevels = this.splitTextIntoNewlineArray( textFile );
            var individualLevelArray;
            var i;
            for ( i = 0; i < tempArrayOfLevels.length; i++ )
            {
                individualLevelArray = this.splitTextIntoNewCommaArray( tempArrayOfLevels[ i ] );
                if( this.isLegitimateLevel( individualLevelArray ) )
                {
                    arrayOfLevelsToReturn[ i ] = individualLevelArray;
                }
            }
            arrayOfLevelsToReturn = this.cast2dStringArrayToInts( arrayOfLevelsToReturn );
            return arrayOfLevelsToReturn;
        },

        splitTextIntoNewlineArray: function( textFile )
        {
            var arrayOfLevels = textFile.split( "\n" );
            return arrayOfLevels;
        },

        splitTextIntoNewCommaArray: function( textFile )
        {
            var individualLevelArray = textFile.split(",");
            return individualLevelArray;
        },

        splitTextIntoNewDashArray: function( textFile )
        {
            var individualPieceArray = textFile.split("/");
            return individualPieceArray;
        },

        cast2dStringArrayToInts: function( arrayToParseToInt )
        {
            var indexFirst;
            var indexSecond;
            var indexThird;

            for( indexFirst = 0; indexFirst < arrayToParseToInt.length; indexFirst++ )
            {
                if( arrayToParseToInt[indexFirst] instanceof Array )
                {
                    for( indexSecond = 0; indexSecond < arrayToParseToInt[indexFirst].length; indexSecond++ )
                    {
                        //if that is also an array
                        if( arrayToParseToInt[indexFirst][indexSecond] instanceof Array )
                        {
                            for( indexThird = 0; indexThird < arrayToParseToInt[indexFirst][indexSecond].length; indexThird++ )
                            {
                               arrayToParseToInt[indexFirst][indexSecond][indexThird] = parseInt( arrayToParseToInt[indexFirst][indexSecond], 10 );
                            } 
                        }
                        else
                        {
                            arrayToParseToInt[indexFirst][indexSecond] = parseInt( arrayToParseToInt[indexFirst][indexSecond], 10 );
                        }   
                    }
                }
            }
            return arrayToParseToInt;
        },

        //checks if level info is correctly parsed
        isLegitimateLevel: function( arrayToCheck )
        {
            var toReturn;
            var index;

            for( index = 0; index < 3; index++ )
            {
                if( !parseInt( arrayToCheck[index], 10 ) )
                {
                    toReturn = false;
                    break;
                }
                else
                {
                    toReturn = true;
                }
            }
            return toReturn;
        }
   	} );
}() );