/*global cc*/
/*global require*/
/*global LumosityButtonState*/
/*global LumosityButton*/
/*global LayoutLoader*/
/*global LayoutNodeFlags*/
/*global LumosityUtils*/
/*global AnimationController*/

require( "src/View/LumosityButton.js" );
require( "src/Animation/LayoutLoader.js" );
require( "src/Utility/LumosityUtils.js" );
require( "src/Animation/AnimationController.js" );

var Nebula;
( function()
{
    "use strict";

    Nebula = cc.Node.extend(
        {
            controller: null,
            sprite: null,
            spriteAnimationController: null,

            /** @lends Nebula.prototype */
            /**
             *  Nebula is the main class for a Nebula view!
             *
             *  @constructs
             */
            ctor:function( controller, view, contentSize )
            {
                this._super();
                this.controller = controller;
                this.setContentSize( contentSize );
                this.loadLayout();
                this._createAnimationController( view, contentSize );
                this.nodeName = "Nebula";
            },

            setupChildren: function()
            {
                this.nebula1.setRotation( -86 );
                this.nebula2.setRotation( 0 );
                this.nebula3.setRotation( 4.5 );
                this.nebula4.setRotation( -74 );
                this.nebula5.setRotation( 22 );
                this.nebula5.setScale( cc.size (-1, 1));
                this.nebula6.setRotation( 43 );
                this.nebula6.setScale( cc.size (1, -1));
            },

            //load the unique layout file for nebula animations
            loadLayout: function()
            {
                LayoutLoader.loadLayoutFile( "layoutNebula.json", this, this , this );
            },

            /**
             *  Creates this view's AnimationController since the nebulas animate independent of the main timeline
             */
            _createAnimationController:function( view, contentSize )
            {
                var animFile = "animationsNebula.json";
                this.spriteAnimationController = new AnimationController( animFile, this, this); //, this, contentSize, this.getContentSize() );
                for( var i = 1; i < 7; i++)
                {
                    this["nebula"+i].setAnchorPoint( cc.p(.5,.5));
                    AnimationChanges.addNodeIgnoredChanges( this["nebula"+i], [ AnimationChanges.Rotation ] );
                }
            },

            //create actual nebula sprite
            createButton: function ( contentSize )
            {
                this.sprite = cc.Sprite.create( "menu/circle.png" );
                this.sprite.setColor( cc.RED );
                this.sprite.setOpacity ( 255 );
                this.sprite.setPosition( cc.p (contentSize.width/2,contentSize.height/2));
                this.addChild( this.sprite );
            },

            playNebulaAnimation: function ()
            {
                this.spriteAnimationController.play("nebulaAnim", this.animFinished );
            },

            animFinished: function ()
            {
            }

        } );
}() );
