/*global cc*/
/*global require*/
/*global GameSettings*/

var StarSearchSettings;
( function()
{
    "use strict";

    require( "src/Game/Base/GameSettings.js" );
    StarSearchSettings = GameSettings.extend(
    {
        //the time to wait between each star in the outro animation
        starAnimationLength: 0.25,
        scoringLevelPower: 2,
        scoringScale: 0.25,
        //speedIndexes for playing correct feedback sounds
        speedIndex1: 6,
        speedIndex2: 4,
        speedIndex3: 3,

    	palettes: 
    		[
    			{
                    //0
                    //Taken from PaletteCars0
    				shapes:
    				[ 5,3,6 ],
    				colors:
    				[ cc.c3b(248,235,160), cc.c3b(255,192,0), cc.c3b(243,100,79), cc.c3b(78,200,195), cc.c3b(131,61,134) ],
    				textures:
    				[ ]
    			},
    			{
                    //1
                    //Taken from PaletteCars1
    				shapes:
    				[ 5,3,6,8 ],
    				colors:
    				[ cc.c3b(255,192,0), cc.c3b(241,104,42), cc.c3b(169,234,186), cc.c3b(0,137,165), cc.c3b(149,45,84) ],
    				textures:
    				[ ]
    			},
    			{
                    //2
                    //Taken from PaletteCars
    				shapes:
    				[ 14,12,8,6,3,5 ],
    				colors:
    				[ cc.c3b(255,234,40), cc.c3b(243,100,79), cc.c3b(169,234,186), cc.c3b(0,137,165) ],
    				textures:
    				[ ]
    			},
    			{
                    //3
                    //Taken from PaletteCars3
    				shapes:
    				[ 13,12,8,6,1,4,3,5 ],
    				colors:
    				[ cc.c3b(255,192,0), cc.c3b(169,234,186), cc.c3b(0,137,165) ],
    				textures:
    				[ ]
    			},
    			{
                    //4
                    //Taken from PaletteCars4
    				shapes:
    				[ 10,11,8,6,4,3 ],
    				colors:
    				[ cc.c3b(255,192,0), cc.c3b(243,100,79), cc.c3b(78,200,195) ],
    				textures:
    				[ ]
    			},
    			{
                    //5
                    //Taken from PaletteCars7
                    shapes:
                    [ 8,6,3,5,10,11,4,14,19,18,17,16,2,37,36,35,34,33,24,23,32,31,30,29,28,27,26 ],
                    colors:
                    [ cc.c3b(255,192,0), cc.c3b(241,104,42), cc.c3b(169,234,186), cc.c3b(0,137,165) ],
                    textures:
                    [ ]
                },
    			{
                    //6
                    //Taken from PaletteCars5
                    shapes:
                    [ 32,31,30,29,28,27,26,24,23,19,18,17,16,2,13,10,11,4,14,8,6,3,5 ],
                    colors:
                    [ cc.c3b(255,192,0), cc.c3b(243,100,79), cc.c3b(0,137,165), cc.c3b(149,45,84) ],
                    textures:
                    [ ]
                },
    			{
                    //7
                    //Taken from PaletteCars6
                    shapes:
                    [ 17,16,8,9,13,10,11,7,4,31,29,28,27,24,23,19 ],
                    colors:
                    [ cc.c3b(169,234,186), cc.c3b(255,192,0), cc.c3b(243,100,79), cc.c3b(0,137,165), cc.c3b(149,45,84) ],
                    textures:
                    [ ]
                },
    			{
                    //8
                    //Taken from PaletteCars8
    				shapes:
    				[ 31,30,29,28,27,24,23,19,17,16,8,9,10,11,7,1,4 ],
    				colors:
                    //Call Mike Shedwards. He loves it
    				[ cc.c3b(248,235,160), cc.c3b(255,192,0), cc.c3b(107,199,231), cc.c3b(131,61,134) ],
    				textures:
    				[ ]
    			},
    			{
                    //9
                    //Taken from PaletteCars9
    				shapes:
    				[ 14,8,6,5,13,4,19,18,17,16,2,9,7,15,1,32,31,30,29,28,27,26,24,23 ],
    				colors:
    				[ cc.c3b(241,104,42), cc.c3b(169,234,186), cc.c3b(0,137,165) ],
    				textures:
    				[ ]
    			}
    		]

    } );
}() );
