"use strict";
var Count = {};



/**
 * @param   counts      Key incremented, in place.
 * @return  counts for chaining.
 * Example @see TestCount
 */
Count.increment = function(counts, key)
{
    if (!(key in counts)) {
        counts[key] = 0;
    }
    counts[key]++;
    return counts;
}

/**
 * Difference of values.  Expects values are numbers.
 * Example @see TestCount
 */
Count.subtract = function(countsA, countsB)
{
    var difference = {};
    for (var a in countsA) {
        difference[a] = countsA[a];
        if (null != countsB[a]) {
            difference[a] -= countsB[a];
        }
    }
    for (var b in countsB) {
        if (null == countsA[b]) {
            difference[b] = 0 - countsB[b];
        }
    }
    return difference;
}

/**
 * Example @see TestCount
 */
Count.array = function(elements, key)
{
    var count = 0;
    for (var e = 0; e < elements.length; e++) {
        if (key === elements[e]) {
            count++;
        }
    }
    return count;
}

/**
 * @param   array   Elements are cast to string.
 * Example @see TestCount
 */
Count.each = function(elements)
{
    var counts = {};
    for (var e = 0; e < elements.length; e++) {
        Count.increment(counts, elements[e]);
    }
    return counts;
}
