"use strict";
var Variance = {};



/**
 * Population variance in tree height of each leaf from the root.
 * Example: @see TestTileTree in ../games/railroadSwitch/
 *          @see Search in ../games/taxiPlanner
 *          @see Metadata in ../games/multitasking
 * 13/6/26 Tyler may expect higher difficulty has a less balanced tree.
 * https://trello.com/card/13-railroad-switch-interpolate-density-and-variety-between-levels-with-different-number-of-destinations/506b18c9ad088b7d31d56a4f/643
 */
Variance.variance = function(numbers)
{
    var variance = 0.0;
    var length = numbers.length;
    if (1 <= length) {
        var sum;
        var mean;
        var n;
        sum = 0;
        for (n = 0; n < length; n++) {
            sum += numbers[n];
        }
        mean = sum / length;
        sum = 0;
        for (n = 0; n < length; n++) {
            sum += Math.pow(numbers[n] - mean, 2);
        }
        variance = sum / length;
    }
    return variance;
}
